Friday, March 16, 2012

Moving Entity Along A Curve

I have been working much less on AutoCAD these days, thus have not posted something for quite a while.

A while ago, I was asked by one of the users of the CAD tools I developed before that if it is possible to write some code so that CAD user can drag an entity along a given path. "It surely can be done", I said to the user immediately, " but I have not tried it yet" I added. I was thinking that it can be done with a DrawJig. I did not find time write some code to materialize it until now.

The idea of doing it is fairly simple: just implementing a DrawJig, and in the Jig's Sampler() method, instead of letting the entity follow the a cursor's path during dragging, we can find a point for the entity to move to in such way that the point must be on a curve (moving path). Therefore, we need a Curve entity as our moving path.

Also, since the goal is to give user visual feedback while entity is dragged and the entity moving is only to occur after the drag (should user not cancel the dragging), I use a cloned, non-database-residing entity as the visually moving part, which is disposed when the dragging is done.

Here is the class GuidedMovingJig:

Code Snippet
  1. using Autodesk.AutoCAD.ApplicationServices;
  2. using Autodesk.AutoCAD.DatabaseServices;
  3. using Autodesk.AutoCAD.EditorInput;
  4. using Autodesk.AutoCAD.Geometry;
  5.  
  6. namespace NormJigs
  7. {
  8.     public class GuidedMovingJig : DrawJig
  9.     {
  10.         private Entity _entity=null;
  11.         private Curve _curve=null;
  12.         private Entity _offsetEntity = null;
  13.         private Document _dwg;
  14.         private Editor _ed;
  15.         private Transaction _tran = null;
  16.  
  17.         private Point3d _originalPoint;
  18.         private Point3d _previousPoint;
  19.         private Point3d _currentPoint;
  20.         private Point3d _finalPoint;
  21.  
  22.         private bool _dragCancelled = false;
  23.  
  24.         public GuidedMovingJig()
  25.         {
  26.             _dwg = Application.DocumentManager.MdiActiveDocument;
  27.             _ed = _dwg.Editor;
  28.         }
  29.  
  30.         public void DoDrag()
  31.         {
  32.             _dragCancelled = false;
  33.  
  34.             using (_tran =
  35.                 _dwg.Database.TransactionManager.StartTransaction())
  36.             {
  37.                 if (GetEntities())
  38.                 {
  39.                     _entity.UpgradeOpen();
  40.  
  41.                     try
  42.                     {
  43.                         _entity.Highlight();
  44.  
  45.                         //Generate a clone entity as moving target
  46.                         using (_offsetEntity = _entity.Clone() as Entity)
  47.                         {
  48.                             _offsetEntity.SetDatabaseDefaults();
  49.  
  50.                             //Place the moving target on guiding curve
  51.                             Vector3d displacement =
  52.                                 _originalPoint.GetVectorTo(_currentPoint);
  53.                             _offsetEntity.TransformBy(
  54.                                 Matrix3d.Displacement(displacement));
  55.  
  56.                             //Start drag
  57.                             _ed.Drag(this);
  58.                         }
  59.  
  60.                         //Move the entity to picked location after dragging
  61.                         if (!_dragCancelled)
  62.                         {
  63.                             if (_finalPoint != _originalPoint)
  64.                             {
  65.                                 MoveEntity();
  66.                             }
  67.                         }
  68.                     }
  69.                     finally
  70.                     {
  71.                         //Make sure the entity is unhighlighted
  72.                         _entity.Unhighlight();
  73.                     }
  74.                 }
  75.  
  76.                 _tran.Commit();
  77.             }
  78.         }
  79.  
  80.         protected override SamplerStatus Sampler(JigPrompts prompts)
  81.         {
  82.             JigPromptPointOptions jigOpt = new JigPromptPointOptions();
  83.             jigOpt.UserInputControls =
  84.                 UserInputControls.Accept3dCoordinates |
  85.                 UserInputControls.NoZeroResponseAccepted |
  86.                 UserInputControls.NoNegativeResponseAccepted;
  87.  
  88.             jigOpt.Message =
  89.                 "\nMove to (pick a point or press Esc to cancel): ";
  90.  
  91.             PromptPointResult movePt = prompts.AcquirePoint(jigOpt);
  92.  
  93.             if (movePt.Status == PromptStatus.Cancel)
  94.             {
  95.                 _dragCancelled = true;
  96.                 return SamplerStatus.Cancel;
  97.             }
  98.             else
  99.             {
  100.                 if (_previousPoint == movePt.Value)
  101.                     return SamplerStatus.NoChange;
  102.  
  103.                 _currentPoint =
  104.                     _curve.GetClosestPointTo(movePt.Value, false);
  105.  
  106.                 //Move the entity along the guiding curve
  107.                 Vector3d displacement =
  108.                     _previousPoint.GetVectorTo(_currentPoint);
  109.                 _offsetEntity.TransformBy(
  110.                     Matrix3d.Displacement(displacement));
  111.  
  112.                 _previousPoint = _currentPoint;
  113.                 _finalPoint = _currentPoint;
  114.  
  115.                 return SamplerStatus.OK;
  116.             }
  117.         }
  118.  
  119.         protected override bool WorldDraw(
  120.             Autodesk.AutoCAD.GraphicsInterface.WorldDraw draw)
  121.         {
  122.             draw.Geometry.Draw(_offsetEntity);
  123.             return true;
  124.         }
  125.  
  126.         #region private methods
  127.  
  128.         private bool GetEntities()
  129.         {
  130.             //Pick entity to be moved
  131.             PromptEntityOptions entOpt =
  132.                 new PromptEntityOptions("\nPick a moving entity: ");
  133.             entOpt.SetRejectMessage(
  134.                 "Invalid pick: must be AutoCAD entity.");
  135.             entOpt.AddAllowedClass(typeof(Entity), false);
  136.             PromptEntityResult entRes = _ed.GetEntity(entOpt);
  137.             if (entRes.Status == PromptStatus.OK)
  138.             {
  139.                 _entity = (Entity)_tran.GetObject(
  140.                     entRes.ObjectId, OpenMode.ForRead);
  141.  
  142.                 //Use picked point as default moving base point
  143.                 Point3d pickedPt = entRes.PickedPoint;
  144.  
  145.                 PromptPointOptions ptOpt = new PromptPointOptions(
  146.                     "\nPick moving entity's base point: <" +
  147.                     pickedPt.X.ToString() + "," +
  148.                     pickedPt.Y.ToString() + ">:");
  149.                 ptOpt.AllowNone = true;
  150.  
  151.                 PromptPointResult ptRes = _ed.GetPoint(ptOpt);
  152.                 if (ptRes.Status == PromptStatus.OK)
  153.                 {
  154.                     pickedPt = ptRes.Value;
  155.                 }
  156.                 else if (ptRes.Status == PromptStatus.None)
  157.                 {
  158.                     //Do nothing
  159.                 }
  160.                 else
  161.                 {
  162.                     return false;
  163.                 }
  164.  
  165.                 _originalPoint = pickedPt;
  166.                 
  167.             }
  168.             else
  169.             {
  170.                 return false;
  171.             }
  172.  
  173.             //Pick guiding curve
  174.             PromptEntityOptions curOpt = new PromptEntityOptions(
  175.                 "\nPick a line/polyline/arc/circle as moving path: ");
  176.             curOpt.SetRejectMessage(
  177.                 "Invalid pick: must be a line, polyline, arc or circle.");
  178.             curOpt.AddAllowedClass(typeof(Curve), false);
  179.             PromptEntityResult curRes = _ed.GetEntity(curOpt);
  180.             if (curRes.Status == PromptStatus.OK)
  181.             {
  182.                 _curve = (Curve)_tran.GetObject(
  183.                     curRes.ObjectId, OpenMode.ForRead);
  184.             }
  185.             else
  186.             {
  187.                 return false;
  188.             }
  189.  
  190.             _currentPoint =
  191.                 _curve.GetClosestPointTo(_originalPoint, false);
  192.             _previousPoint = _currentPoint;
  193.             _finalPoint = _currentPoint;
  194.  
  195.             return true;
  196.         }
  197.  
  198.         private void MoveEntity()
  199.         {
  200.             Vector3d displacement =
  201.                 _originalPoint.GetVectorTo(_finalPoint);
  202.             _entity.TransformBy(
  203.                 Matrix3d.Displacement(displacement));
  204.         }
  205.  
  206.         #endregion
  207.     }
  208. }

Since the code wraps all user input actions (picking moving entity and its moving base point, picking moving path), it is really simple to use GuidedMovingJig class. Here the command method to use it:

Code Snippet
  1. using Autodesk.AutoCAD.ApplicationServices;
  2. using Autodesk.AutoCAD.Runtime;
  3. using Autodesk.AutoCAD.EditorInput;
  4.  
  5. [assembly: CommandClass(typeof(NormJigs.MyCommands))]
  6.  
  7. namespace NormJigs
  8. {
  9.     class MyCommands
  10.     {
  11.         [CommandMethod("MyMove")]
  12.         public void UseMovingJig()
  13.         {
  14.             Document doc = Autodesk.AutoCAD.ApplicationServices.
  15.                 Application.DocumentManager.MdiActiveDocument;
  16.             Editor ed = doc.Editor;
  17.  
  18.             try
  19.             {
  20.                 GuidedMovingJig jig = new GuidedMovingJig();
  21.                 jig.DoDrag();
  22.             }
  23.             catch(System.Exception ex)
  24.             {
  25.                 ed.WriteMessage("\nError: {0}\n", ex.Message);
  26.             }
  27.         }
  28.     }
  29. }

This video clip shows the GuidedMovingJig class in action.

2 comments:

Justin Ralston said...

Norman

Great post, just what I was looking for to help me out on a project. Keep up the great work.

Regards

Justin Ralston
http://c3dxtreme.blogspot.co.nz/

Solidworks 2012 said...

Is Blender comparable to architectural CAD programs like form Z or autoCAD?

Solidworks 2012

Followers

About Me

My Photo
After graduating from university, I worked as civil engineer for more than 10 years. It was AutoCAD use that led me to the path of computer programming. Although I now do more generic business software development, such as enterprise system, timesheet, billing, web services..., AutoCAD related programming is always interesting me and I still get AutoCAD programming tasks assigned to me from time to time. So, AutoCAD goes, I go.